#!/usr/bin/perl -w

my $infile = STDIN;
my $outfile = STDOUT;
my $maxRouter = 0;
my $amongNodes = 0;
my $amongLans = 0;
my $curlannum = 0;
my $lansize = 0;;
my $count = 0;
my $lanRouter = 0;
my $lanHost = 0;
my ($i, $j);
my $ifprint = 1;
my @curLan;
	   

$lansize = shift;
while($line = <$infile>)
{
    if($ifprint == 1 or $line =~ /^#/)
       { 
	   print $outfile $line;
       }

    if($line =~ /^#\s+LAN/)
       {
	   $ifprint = 0;
       }   

    if($line =~ /^#\s+Node\s+X/) 
       {
	   $amongNodes = 1;
	   #print $outfile $line;
       }else{
	   if($line =~ /^#\s\-+/ and $amongNodes == 1)
	      {
		  #print $outfile $line;
	      }elsif($amongNodes == 1){
		  #print $outfile $line;
		  ($id, $X, $Y, $type) = split(/\s+/, $line);
		  $X = $X; $Y = $Y; # Just to get rid of the warning by perl
		  if($type == 0 || $type == 1) 
		  {
		      $maxRouter = $id;
		  }else{
		      $amongNodes = 0;
		  }
	      }
	  }
    

    if($line =~ /^#\s+LAN\s+(\d+)/)   
       {
	   $curlannum = $1;
	   $amongLans = 2;
	   $count = 0;
       }elsif($line =~ /^#\s+/ and $amongLans == 2)
	      {
		  $amongLans = 1;
	      }elsif($amongLans ==1 and !($line =~ /^#/))
	      {
		  ($from, $to, $delay, $band, $ftype, $ttype, $state)=split(/\s+/, $line);
		  if($from <= $maxRouter) 
		  {
		      $lanRouter = $from; $lanHost = $to;
		  }else{
		      push @curLan, [$from, $to, $delay, $band, $ftype, $ttype, $state];
		  }
		  $count++;	  
	      }elsif(($count == (2*$lansize)) || ($line =~ /^#\s+/ and $amongLans == 1))
		     {
			 for $i (0 .. $#curLan) {
			     for $j (0 .. 1) {
				if($curLan[$i][$j] == $lanHost and $curLan[$i][0] != $lanRouter 
				   and $curLan[$i][1] != $lanRouter)
				{
				  $curLan[$i][$j] = $lanRouter;  
				} 
			     }
			 }
			 
			 $amongLans = 0;	
			 for $lanref (@curLan)
			 {
			     print $outfile "@$lanref\n";
			 }

			 for($i=0;$i<2*$lansize;$i++)
			 {
			     pop @curLan;
			 }
		     }
	   
}#end of while



   for $i (0 .. $#curLan) {
       for $j (0 .. 1) {
	   if($curLan[$i][$j] == $lanHost and $curLan[$i][0] != $lanRouter 
	      and $curLan[$i][1] != $lanRouter)
	   {
	       $curLan[$i][$j] = $lanRouter;  
	   } 
       }
   }
		     
   for $lanref (@curLan)
       {
	   print $outfile "@$lanref\n";
       }
		     

